﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using Grpc.Net.ClientFactory;
using Infinium.Operation.Contract.Relay;
using Microsoft.Extensions.DependencyInjection;
using ProtoBuf.Grpc.ClientFactory;

namespace Infinium.Operation.Client.BridgeClient
{
    partial class MainUI
    {
        [ProtoBuf.ProtoContract]
        internal class cacheLogin
        {
            [ProtoBuf.ProtoMember(1)]
            public bool SignedIn;
            [ProtoBuf.ProtoMember(3)]
            public byte[] LastThumbprint;
        }

        internal enum ChatGroupType : byte
        {
            Undefined = 0,
            GuildChat = 1,
            GuildChannel = 2,
            WorldChat = 3,
            WorldChatEmpire = 4,
            WorldChatLeague = 5,
            GroupChat = 6,
            GroupChannel = 7,
            RaidChat = 8,
            RaidChannel = 9,
            Whisper = 10,
        }

        private class ClientRegis
        {
            private static readonly ServiceProvider _serviceProvider;
            private static readonly System.Net.Http.HttpClientHandler _httpClientHandler;
            //private static readonly Grpc.Net.Client.Web.GrpcWebHandler _grpcWebHandler;
            static ClientRegis()
            {
                System.Net.Http.HttpClientHandler _httpClientHandler = new System.Net.Http.HttpClientHandler();
                _httpClientHandler.ClientCertificates.Add(MainUI.ConnectCertificate);
                //_grpcWebHandler = new Grpc.Net.Client.Web.GrpcWebHandler(Grpc.Net.Client.Web.GrpcWebMode.GrpcWeb, _httpClientHandler);
                var services = new ServiceCollection();
                ConfigureServices(services);
                _serviceProvider = services.BuildServiceProvider();
            }


            private static void ConfigureServices(ServiceCollection services)
            {
                services.AddCodeFirstGrpcClient<IRelayGameChat>(configureClient);
            }

            private static void configureClient(GrpcClientFactoryOptions options)
            {
                options.Address = new Uri("https://127.0.0.1:9933");
                options.ChannelOptionsActions.Add(o => o.HttpHandler = _httpClientHandler);
            }

            [System.Diagnostics.DebuggerStepThrough]
            public static T GetService<T>() => _serviceProvider.GetService<T>();
        }
    }
}
